//
//  ViewController.swift
//  TKCocoaModule
//
//  Created by zhuamaodeyu on 10/07/2019.
//  Copyright (c) 2019 zhuamaodeyu. All rights reserved.
//

import Cocoa
import TKCocoaModule
import SnapKit

class ViewController: NSViewController {

    override func viewDidLoad() {
        let view = NSView.init()
        view.cocoa.backgroundColor
    }
}


extension ViewController {
    private func installButton() {
        let button = TKButton.init()
        button.setTitle("normal", for: .normal)
        button.setTitle("Selected", for: .selected)
        button.setTitle("Highlighted", for: .highlighted)
        button.setTitle("disable", for: .disabled)
        button.addTarget(self, action: #selector(buttonAction(_:)), for: .upInside)
        button.setImage(NSImage.init(named: "common_purpie_radio_selected"), for: .normal)
        view.addSubview(button)
        button.imagePosition = .imageLeft
        button.textAlignment = .left
        button.contentEdget = NSEdgeInsets.init(top: 5, left: 5, bottom: 5, right: 5)
        button.imageEdgeInsets = NSEdgeInsets.init(top: 5, left: 5, bottom: 5, right: 5)
        button.titleEdgeInsets = NSEdgeInsets.init(top: 5, left: 5, bottom: 5, right: 5)
        button.snp.makeConstraints { make in
            make.leading.equalToSuperview()
            make.top.equalToSuperview()
            make.width.equalTo(200)
            make.height.equalTo(50)
        }
    }
    @objc private  func buttonAction(_ sender: TKButton) {
        debugPrint("\(#function)")
//        sender.isEnabled = false
        sender.isSelected  = true
    }
    
    private func installControl () {
        let control = TKControl.init()
        
        view.addSubview(control)
        control.isEnabled = false
        control.keyEquivalent = "\r"
        control.addTarget(self, action: #selector(action(_:)), for : .upInside)
        control.addTarget(self, action: #selector(down(_:)), for: .down)
        control.snp.makeConstraints { make in
            make.leading.top.trailing.equalToSuperview()
            make.height.equalTo(50)
        }
    }
    @objc private  func action(_ sender: TKButton) {
        debugPrint("\(#function)")
    }
    @objc private  func down(_ sender: TKButton) {
        debugPrint("\(#function)")
    }
    
    
    private func installTextField() {
        let textField = TKTextField.init()
        textField.backgroundColor = NSColor.red
        textField.drawsBackground = false
        textField.wantsLayer = false
        textField.isBordered = true
        textField.isBezeled = true
        textField.maximumNumberOfLines = 5
        view.addSubview(textField)
        
        let textField2 = TKTextField.init()
        textField.isEqual(to: textField2)
        
        textField.snp.makeConstraints { make in
            make.left.equalToSuperview().offset(10)
            make.trailing.equalToSuperview().offset(-10)
            make.top.equalToSuperview().offset(50)
            make.height.equalTo(90)
        }
    }
    
    
    private func installLabel() {
        let label = TKLabel.init()
        label.text = "一个按钮可以具有两个与之关联的图像：正常和交替。如果按钮类是NSMomentaryPushInButton，NSPushOnPushOffButton，NSMomentaryLightButton，或NSOnOffButton，只会显示正常图像。如果按钮类型为NSMomentaryChangeButton或NSToggleButton，则在按钮状态为关闭（NSOffState）时显示正常图像。"
        label.numberOfLines = 0
        view.addSubview(label)
        label.textAlignment = .center
        
        label.snp.makeConstraints { make in
            make.left.trailing.equalToSuperview()
            make.top.equalToSuperview().offset(50)
            make.height.equalTo(90)
        }
        
        let label2 = TKLabel.init()
        label2.text = "一个按钮"
        label2.numberOfLines = 1
        label2.font = NSFont.systemFont(ofSize: 15)
        view.addSubview(label2)
        label2.textAlignment = .center
        
        label2.snp.makeConstraints { make in
            make.left.equalToSuperview()
            make.top.equalTo(label.snp.bottom)
//            make.top.equalToSuperview()
//            make.bottom.equalToSuperview()
//            make.trailing.equalToSuperview()
            make.width.equalTo(100)
            make.height.equalTo(50)
//            make.size.equalTo(label2.fittingSize)
        }
        
        debugPrint("\(label2.frame)")
    }
    
    
}
