//
//  CALayer+Exts.swift
//  TKCocoaModule
//
//  Created by 🐶 on 12/22/21.
//

import Foundation
import QuartzCore


extension TypeWrapperProtocol where WrappedType == CALayer {
    public func bringSublayerToFront(_ layer: CALayer) {
        wrappedValue.addSublayer(layer)
        
        if let sublayers = self.wrappedValue.sublayers,let firstLayer = sublayers.first  {
            let maxLayer = sublayers.reduce(firstLayer) { partialResult, layer in
                if partialResult.zPosition > layer.zPosition {
                    return partialResult
                }
                return layer
            }
            layer.zPosition = maxLayer.zPosition + 1
        }else {
            layer.zPosition = 0
        }
    }
    public func sendSublayerToBack(_ layer: CALayer) {
        wrappedValue.addSublayer(layer)
        
        if let sublayers = self.wrappedValue.sublayers,let firstLayer = sublayers.first  {
            let smailLayer = sublayers.reduce(firstLayer) { partialResult, layer in
                if partialResult.zPosition < layer.zPosition {
                    return partialResult
                }
                return layer
            }
            layer.zPosition = smailLayer.zPosition - 1
        }else {
            layer.zPosition = 0
        }
    }
}
