
import Cocoa

extension CGSize {
    static func + (ls: CGSize, rs: CGSize) -> CGSize {
        return CGSize.init(width: ls.width + rs.width, height: ls.height + rs.height)
    }
    static func - (ls: CGSize, rs: CGSize) -> CGSize {
        return CGSize.init(width: ls.width - rs.width, height: ls.height - rs.height)
    }
    static func * (ls: CGSize, rs: CGSize) -> CGSize {
        return CGSize.init(width: ls.width * rs.width, height: ls.height * rs.height)
    }
    static func / (ls: CGSize, rs: CGSize) -> CGSize {
        return CGSize.init(width: ls.width / rs.width, height: ls.height / rs.height)
    }
}


extension NSEdgeInsets {
    static let zero = NSEdgeInsetsZero
}

extension NSTextAlignment {
    var alignmentMode: CATextLayerAlignmentMode {
        switch self {
        case .left:
            return .left
        case .right:
            return .right
        case .center:
            return .center
        case .justified:
            return .justified
        case .natural:
            return .natural
        @unknown default:
            return .init(rawValue: "\(self.rawValue)")
        }
    }
}


/**
 TKControl 定时器还没有实现
 
 
 */

