//
//  VerticallyCenteredTextLayer.swift
//  TKCocoaModule
//
//  Created by 🐶 on 12/21/21.
//
import AppKit

public class VerticallyCenteredTextLayer: CATextLayer {

    public override func draw(in context: CGContext) {

        let fontSize = self.fontSize
        let height = self.bounds.size.height
        let deltaY = (height-fontSize)/2 - fontSize/10

        context.saveGState()
        context.translateBy(x: 0.0, y: -deltaY)
        super.draw(in: context)
        context.restoreGState()
    }
}
